<template>
  <div>
    Mon composant :
    * des props
    * des data
    * des computed property
    * des methods
    * des watchs
    * des lifecycle hooks (created, mounted, ...)
    * et un name
  </div>
</template>

<script>
export default {
  name: 'Test',
  props: {
    maPropriete1: Number,
    maPropriete2: Boolean,
    maPropriete3: {
      type: String,
      default: 'pouet pouet'
    },
    maPropriete4: {
      type: String,
      required: true
    }
  },
  data () {
    return {
      maData1: 0,
      maData2: 'pouic pouic',
      maData3: {
        toto: 'tata'
      },
      maData4: [{
        element: 1
      }, {
        element: 2
      }, {
        element: 3
      }, {
        element: 4
      }, {
        element: 5
      }]
    }
  },
  computed: {
    maComputedProperty1 () {
      return this.maPropriete3 + this.maData2
    },
    maComputedProperty2: {
      get () {
        return this.maPropriete3 + this.maData2
      },
      set (value) {
        this.maPropriete3 = value.substring(1, 3)
        this.maData2 = value.substring(3, value.length)
      }
    }
  },
  methods: {
    updateMaData1 (newData1) {
      this.maData1 = newData1 + 'je t modifié'
      console.log(this.maComputedProperty1)

      const _this = this
      this.maData4.forEach(function (maDataCourante) {
        console.log(_this, this, this !== _this)
      })

      this.maData4.forEach(function (maDataCourante) {
        console.log(this)
      }.bind(this))

      this.maData4.forEach(maDataCourante => {
        console.log(this)
      })
    }
  },
  watch: {
    maData1 (newValue, oldValue) {
      this.updateMaData1(newValue)
    },
    maData3: {
      handler (newValue, oldValue) {

      },
      immediate: true,
      deep: true
    },
    'maData3.toto' (newValue, oldValue) {

    }
  },
  created () {
    this.updateMaData1()
  },
  mounted () {

  }
}
</script>

<style scoped>

</style>
